#ifndef __BMP_LOADER_H__
#define __BMP_LOADER_H__

#include <stdio.h>

#include "types.h"

struct BMPColor {
  byte blue;
  byte green;
  byte red;
  byte _a;
};

struct BMPImage {
  int width;
  int height;
  word bpp;
  struct BMPColor colors[256];
  byte *memoryStart;

  int transparentColor;
};

int readBMPIntoMemory(FILE *, struct BMPImage *);
int readBMPIntoNewMemory(FILE *, struct BMPImage *);
void bmp256ColorPaletteToVGAColorPalette(struct BMPImage*, struct VGAColor[]);
void freeBMP(struct BMPImage *);

#endif
